leetcode: 198. House Robber dp

来源:互联网 发布:kpmg 大数据招聘 编辑:程序博客网 时间:2024/05/18 04:58

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed, the only constraint stopping you from robbing each of them is that adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

动态规划解决,用dp数组求出每个状态的最大值,步步最优解。

递推关系式:dp[i]=max(dp[i-2]+nums[i],dp[i-1])  因为不能相邻并且最大值所以i-2,跟他相邻的最大值也就i-1

class Solution {public:    int rob(vector<int>& nums) {        if (nums.size()==0)            return 0;        if (nums.size()==1)            return nums[0];        vector<int> dp(nums.size(),0);        dp[0]=nums[0];        dp[1]=max(nums[0],nums[1]);        for (int i=2;i<nums.size();i++)            dp[i]=max(dp[i-2]+nums[i],dp[i-1]);        return dp[nums.size()-1];            }};


0 0